/*
 *
 *     This file is a part of the SteamWar software.
 *
 *     Copyright (C) 2020  SteamWar.de-Serverteam
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Affero General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *     GNU Affero General Public License for more details.
 *
 *     You should have received a copy of the GNU Affero General Public License
 *     along with this program.  If not, see <https://www.gnu.org/licenses/>.
 * /
 */

package de.steamwar.bausystem.tracer;

import org.bukkit.util.Vector;

import java.util.Objects;

public class RoundedTNTPosition {

    private static final int factor = 10;

    private int x;
    private int y;
    private int z;

    public RoundedTNTPosition(TNTPosition tntPosition) {
        this(tntPosition.getLocation().getX(), tntPosition.getLocation().getY(), tntPosition.getLocation().getZ());
    }

    public RoundedTNTPosition(Vector vector) {
        this(vector.getX(), vector.getY(), vector.getZ());
    }

    public RoundedTNTPosition(double x, double y, double z) {
        this.x = (int) (x * factor);
        this.y = (int) (y * factor);
        this.z = (int) (z * factor);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof RoundedTNTPosition)) return false;
        RoundedTNTPosition that = (RoundedTNTPosition) o;
        return x == that.x &&
                y == that.y &&
                z == that.z;
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y, z);
    }

}
